// ---------------------------------------------------------------------------
//	Device関連クラス
//	  Original     : cisc
//	  Modification : Yumitaro
// ---------------------------------------------------------------------------

#include <string.h>
#include <new>

#include "device.h"



////////////////////////////////////////////////////////////////
// DeviceList
////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////
// コンストラクタ
////////////////////////////////////////////////////////////////
// 8888888888888888888888888888888888888
//DeviceList::DeviceList( void ) : node(NULL) {}
// 8888888888888888888888888888888888888
DeviceList::DeviceList( void ) {}
// 8888888888888888888888888888888888888


////////////////////////////////////////////////////////////////
// デストラクタ
////////////////////////////////////////////////////////////////
DeviceList::~DeviceList( void )
{
	Cleanup();
}


////////////////////////////////////////////////////////////////
// ノード検索
////////////////////////////////////////////////////////////////
DeviceList::Node *DeviceList::FindNode( const ID id )
{
// 8888888888888888888888888888888888888
//	for( Node *n = node; n; n = n->next ){
//		if( n->entry->GetID() == id )
//			return n;
//	}
// 8888888888888888888888888888888888888
	auto p = nodeMap.find( id );
	if( p != nodeMap.end() ){
		return &p->second;	// 要素の値を返す (first:キー second:値)
	}
// 8888888888888888888888888888888888888
	return NULL;
}


////////////////////////////////////////////////////////////////
// デバイスリスト全消去
////////////////////////////////////////////////////////////////
void DeviceList::Cleanup( void )
{
// 8888888888888888888888888888888888888
//	Node *n = node;
//	while( n ){
//		Node *nx = n->next;
//		delete n;
//		n = nx;
//	}
//	node = NULL;
// 8888888888888888888888888888888888888
	nodeMap.clear();
// 8888888888888888888888888888888888888
}


////////////////////////////////////////////////////////////////
// デバイス追加
////////////////////////////////////////////////////////////////
bool DeviceList::Add( IDevice *t )
{
	ID id = t->GetID();
	if( !id ) return false;
	
	Node *n = FindNode( id );
	if( n ){
		n->count++;
		return true;
	}else{
// 8888888888888888888888888888888888888
//		n = new Node;
//		if( !n ) return false;
//		n->entry = t;
//		n->next  = node;
//		n->count = 1;
//		node = n;
// 8888888888888888888888888888888888888
		Node& n = nodeMap[id];
		n.entry = t;
		n.count = 1;
// 8888888888888888888888888888888888888
		return true;
	}
}


////////////////////////////////////////////////////////////////
// デバイス削除(ポインタ)
////////////////////////////////////////////////////////////////
bool DeviceList::Del( IDevice *t )
{
	return t->GetID() ? Del( t->GetID() ) : false;
}


////////////////////////////////////////////////////////////////
// デバイス削除(ID)
////////////////////////////////////////////////////////////////
bool DeviceList::Del( const ID id )
{
// 8888888888888888888888888888888888888
//	for( Node **r = &node; *r; r = &((*r)->next) ){
//		if( ((*r)->entry->GetID() == id) && ((*r)->count) ){
//			((*r)->count)--;
////		if( (*r)->entry->GetID() == id ){
////			Node* d = *r;
////			if( !--d->count ){
////				*r = d->next;
////				delete d;
////			}
//			return true;
//		}
//	}
// 8888888888888888888888888888888888888
	if( Node *n = FindNode(id) ){
		n->count--;
		return true;
	}
// 8888888888888888888888888888888888888
	return false;
}


////////////////////////////////////////////////////////////////
// デバイス検索
////////////////////////////////////////////////////////////////
IDevice *DeviceList::Find( const ID id )
{
	Node *n = FindNode( id );
	return n ? n->entry : NULL;
}
